<?php
/**
 * Plugin Name: Petroleum King Delivery Detail Plugin
 * Plugin URI: http://petroleumkings.com
 * Description: Plugin to allow admin to set the oil delivery limits
 * Version: 1.0
 * Author: Waqas Ahmed
 * Author URI: http://tinyfrog.com
 * License: GPL2
 */

 /** Rendering the search form when the shortcode is placed **/
function render_oil_search( $atts ) {
	/** Check if form has been submitted - if yes then search database and show result **/
	$search_message = '';
	if (isset($_POST['zipcode'])) {
		global $wpdb;
		$oil_table = $wpdb->prefix . 'petrol_king_oil';
		$search_result = $wpdb->get_row( 'SELECT * FROM '.$oil_table.' WHERE zipcode = "' . $_POST['zipcode'] . '"');
		
		if ($search_result == null) {
			$search_message = "<h2>Sorry we do not supply oil to this zip code</h2>";
		}
		else {
			$search_message = "<h2>Yes! We service your area. The minimum order is ".$search_result->quantity." gallons.</h2>";
		}
	}
	
	/** Output the form here **/
	$output = $search_message . "<form action='' method='POST'>
					<input type='text' name='zipcode' placeholder='Enter zip code to search' />
					<input type='submit' value='Search Zip Code' />
					</form>";
	return $output;
}
add_shortcode( 'oil_search', 'render_oil_search' );


/** Rendering the form to add/delete data **/
function render_oil_data( $atts ) {
	global $wpdb;
	$oil_table = $wpdb->prefix . 'petrol_king_oil';

	if (is_user_logged_in()) {
		/** Check if form has been submitted - if yes then search database and show result **/
		$insert_message = '';
		if (isset($_POST['zipcode']) && isset($_POST['quantity']) && isset($_POST['city'])) {
			
			// Check if the entry for the zip code already exists
			$search_result = $wpdb->get_row( 'SELECT * FROM '.$oil_table.' WHERE zipcode = "' . $_POST['zipcode'] . '" AND city = "'.$_POST['city'].'"');
			
			if ($search_result == null) {
				$insert_result = $wpdb->insert( $oil_table, array('zipcode' => $_POST['zipcode'], 'city' => $_POST['city'], 'quantity' => $_POST['quantity']), array ('%s', '%s', '%d'));
				
				if (!$insert_result) {
					$insert_message = "<h2>Problem adding data. Please try again</h2>";
				}
				else {
					$insert_message = "<h2>Record added successfully.</h2>";
				}
			}
			else {
				$insert_message = "<h2>Entry for this zip code already exists</h2>";
			}
		}
		
		/** Check if an entry has to be deleted and does that if needed **/
		if (isset($_GET['deleteid'])) {
			$deletion_result = $wpdb->delete( $oil_table, array('zipcode' => $_GET['deleteid']), array( '%s' ) );
		}

		
		/** List all the current data **/
		$complete_oil_data =$wpdb->get_results( 'SELECT * FROM '. $oil_table .' ORDER BY quantity, zipcode');
		$oil_data_result = "<table border='1' id='oil_data_table'><thead><th>Zip Code</th><th>City</th><th>Quantity</th><th></th></thead><tbody>";
		foreach ($complete_oil_data as $oil_data) {
			$oil_data_result .= "<tr>
									<td>
									". $oil_data->zipcode . "
									</td>
									<td>
									". $oil_data->city . "
									</td>
									<td>
									". $oil_data->quantity . "
									</td>
									<td>
									<a href='".get_permalink()."?deleteid=".$oil_data->zipcode."'>Delete</a>
								</tr>";
		}
		$oil_data_result .= "</tbody> </table> <p>&nbsp;</p>";
		

		
		/** Output the form that adds data here **/
		$output = $oil_data_result . $insert_message . "<form action='".get_permalink()."' method='POST'>
						Zip code<br /> <input type='text' name='zipcode' placeholder='Enter zip code to add' /> <br /><br />
						City <br /> <input type='text' name='city' placeholder='Enter city' /> <br /><br />
						Quantity <br /><input type='text' name='quantity' placeholder='Enter quantity' /> <br /><br />
						<input type='submit' value='Add Entry' />
						</form>";
	}
	else {
		$output = "<h2>Sorry this page is restricted - please login with the correct user to view this page</h2>";
	}
	return $output;
}
add_shortcode( 'oil_data', 'render_oil_data' );